-------------------------------------------------------------------------------
-- File name : dff.vhdl
-- Title     : D flip flop with Set/Reset
-- project   : ECE 485
-- Library   : single-cycle processor
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of single-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity dff_sr is
  port (d     : in  std_logic;
        clk   : in  std_logic;
        reset : in  std_logic;
        set   : in  std_logic;
        q     : out std_logic);
end dff_sr;

architecture behavior of dff_sr is
begin
  process (clk, set, reset)
  begin
    if reset = '0' then
      q <= '0';
    elsif set = '0' then
      q <= '1';
    elsif (clk'event and clk = '1') then
      q <= d;
    end if;
  end process;
end behavior;
