-------------------------------------------------------------------------------
-- File name : mux21x32.vhdl
-- Title     : 2-1 x 32-bit Multiplexor
-- project   : ECE 485
-- Library   : single-cycle processor
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of single-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity mux21x32 is
  port (A : in  std_logic_vector(31 downto 0);
        B : in  std_logic_vector(31 downto 0);
        S : in  std_logic;
        Y : out std_logic_vector(31 downto 0));
end mux21x32;

architecture structure of mux21x32 is

  component mux21 
    port (D0 : in  std_logic;
          D1 : in  std_logic;
          S0 : in  std_logic;
          Y  : out std_logic);
  end component;
  
begin

  mx1  : mux21 port map (A(0), B(0), S, Y(0));
  mx2  : mux21 port map (A(1), B(1), S, Y(1));
  mx3  : mux21 port map (A(2), B(2), S, Y(2));
  mx4  : mux21 port map (A(3), B(3), S, Y(3));
  mx5  : mux21 port map (A(4), B(4), S, Y(4));
  mx6  : mux21 port map (A(5), B(5), S, Y(5));
  mx7  : mux21 port map (A(6), B(6), S, Y(6));
  mx8  : mux21 port map (A(7), B(7), S, Y(7));
  mx9  : mux21 port map (A(8), B(8), S, Y(8));
  mx10 : mux21 port map (A(9), B(9), S, Y(9));

  mx11 : mux21 port map (A(10), B(10), S, Y(10));
  mx12 : mux21 port map (A(11), B(11), S, Y(11));
  mx13 : mux21 port map (A(12), B(12), S, Y(12));
  mx14 : mux21 port map (A(13), B(13), S, Y(13));
  mx15 : mux21 port map (A(14), B(14), S, Y(14));
  mx16 : mux21 port map (A(15), B(15), S, Y(15));
  mx17 : mux21 port map (A(16), B(16), S, Y(16));
  mx18 : mux21 port map (A(17), B(17), S, Y(17));
  mx19 : mux21 port map (A(18), B(18), S, Y(18));
  mx20 : mux21 port map (A(19), B(19), S, Y(19));

  mx21 : mux21 port map (A(20), B(20), S, Y(20));
  mx22 : mux21 port map (A(21), B(21), S, Y(21));
  mx23 : mux21 port map (A(22), B(22), S, Y(22));
  mx24 : mux21 port map (A(23), B(23), S, Y(23));
  mx25 : mux21 port map (A(24), B(24), S, Y(24));
  mx26 : mux21 port map (A(25), B(25), S, Y(25));
  mx27 : mux21 port map (A(26), B(26), S, Y(26));
  mx28 : mux21 port map (A(27), B(27), S, Y(27));
  mx29 : mux21 port map (A(28), B(28), S, Y(28));
  mx30 : mux21 port map (A(29), B(29), S, Y(29));

  mx31 : mux21 port map (A(30), B(30), S, Y(30));
  mx32 : mux21 port map (A(31), B(31), S, Y(31));

end structure;
