-- Logic for CLA
-- Author: John Moskal
--  Created: 11-27-04
-- Modified: 11-27-04
--
-- Modifications:
--
------------------------------------------------------------------------------------------
library work;
library ieee;
use ieee.std_logic_1164.all;

entity RFA is
port
(
   A,B: in std_logic;
   cin: in std_logic;
   p,g: out std_logic;
   R:   out std_logic
);
end entity RFA;

architecture stuff of RFA is

signal p_w:   std_logic;
signal g_w:   std_logic;
signal x_w:   std_logic;

begin
    
    g_w <= A and B;
    g <= g_w;
    p_w <= A or B;
    p <= p_w;
    x_w <= (not g_w) and p_w;
    R <= (not(x_w and cin)) and (x_w or cin);
    
end stuff;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------

library work;
library ieee;
use ieee.std_logic_1164.all;

entity RFAx is
port
(
   A,B: in std_logic;
   cin: in std_logic;
   p,g: out std_logic;
   R:   out std_logic;
   X:   out std_logic
);
end entity RFAx;

architecture stuff of RFAx is

signal p_w:   std_logic;
signal g_w:   std_logic;
signal x_w:   std_logic;

begin
    
    g_w <= A and B;
    g <= g_w;
    p_w <= A or B;
    p <= p_w;
    x_w <= (not g_w) and p_w;
    X <= x_w;
    R <= (not(x_w and cin)) and (x_w or cin);
    
end stuff;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------

library work;
library ieee;
use ieee.std_logic_1164.all;

entity BCLG is
port
(
   pin:   in std_logic_vector(3 downto 0);
   gin:   in std_logic_vector(3 downto 0);
   c0:            in std_logic;
   c1,c2,c3:      out std_logic;
   P,G:           out std_logic
);
end entity BCLG;

architecture stuff of BCLG is

signal p3,p2,p1,p0:   std_logic;
signal g3,g2,g1,g0:   std_logic;

begin
    
    p3 <= pin(3);
    p2 <= pin(2);
    p1 <= pin(1);
    p0 <= pin(0);

    g3 <= gin(3);
    g2 <= gin(2);
    g1 <= gin(1);
    g0 <= gin(0);
    
   c1 <= g0 or (p0 and c0);
   c2 <= g1 or (p1 and g0) or (p1 and p0 and c0);
   c3 <= g2 or (p2 and g1) or (p2 and p1 and g0) or (p2 and p1 and p0 and c0);
   
   P <= p3 and p2 and p1 and p0;
   G <= g3 or (p3 and g2) or (p3 and p2 and g1) or (p3 and p2 and p1 and g0);
    
end stuff;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------

library work;
library ieee;
use ieee.std_logic_1164.all;

entity BCLGL is
port
(
   p0,p1:   in std_logic;
   g0,g1:   in std_logic;
   c0:      in std_logic;
   c1:      out std_logic;
   cout:    out std_logic
);
end entity BCLGL;

architecture stuff of BCLGL is

begin
    
   c1 <= g0 or (p0 and c0);
 
   cout <= (g1 or (p1 and g0)) or ((p1 and p0) and c0);

end stuff;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- Special Adder (RFA with B always assumed to be 0) - simpler logic and faster

library work;
library ieee;
use ieee.std_logic_1164.all;

entity SRFA is
port
(
   A:   in std_logic;
   cin: in std_logic;
   p:   out std_logic;
   R:   out std_logic  

);
end entity SRFA;

architecture stuff of SRFA is

signal a_w:   std_logic;

begin
    
    a_w <= A;
    p <= a_w;
    R <= (not(a_w and cin)) and (a_w or cin);
    
end stuff;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- used when B(x) = 0 --> then all Generates are 0

library work;
library ieee;
use ieee.std_logic_1164.all;

entity SBCLG is
port
(
   p:        in std_logic_vector(3 downto 0);
   c0:       in std_logic;
   c1,c2,c3: out std_logic;
   PP:       out std_logic
);
end entity SBCLG;

architecture stuff of SBCLG is

begin
    
c1 <= p(0) and c0;
c2 <= p(1) and p(0) and c0;
c3 <= p(2) and p(1) and p(0) and c0;

PP <= p(3) and p(2) and p(1) and p(0);
    
end stuff;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------

