-------------------------------------------------------------------------------
-- File name : memory.vhd
-- Title     : Memory modules
-- project   : ECE 485
-- Library   : multi-cycle processor
-- Author(s) : Ivan Castellanos
-- Purpose   : definition of multi-cycle processor
-- notes     : non-synthesizable (only for testing)
--           : also contains Wishbone interface

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.ALL;
use std.textio.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

use IEEE.std_logic_textio.all;
--use ieee.numeric_std.all;

entity memdata512 is
port
(
   clk       : in  std_logic;
   memwrite  : in  std_logic;
   adr       : in  std_logic_vector(8 downto 0);
   writedata : in  std_logic_vector(31 downto 0);
   memdata   : out std_logic_vector(31 downto 0)
);
end memdata512;

architecture struct of memdata512 is
    
begin
  process(clk, adr) is
                    variable l : line;
                    variable first : boolean := true;
                    variable ch : character;
                    variable index : integer :=0;
                    type ramtype is array (511 downto 0) of std_logic_vector(31 downto 0);
                    variable mem : ramtype;
  begin

    if first then
      first:=false;

      for i in 0 to 511 loop
        --mem(conv_integer(i)):="00000000000000000000000000000000";
        --mem(conv_integer(i)):=CONV_STD_LOGIC_VECTOR(CONV_UNSIGNED(i, 32),32);
        mem(conv_integer(i)):=CONV_STD_LOGIC_VECTOR(i,32); 
      end loop;  

    else
        memdata <= mem(conv_integer(adr));
        
       if(clk'event and clk='0') then
           write(l, now);
           write(l, string'(" (DM) - Address: "));
           write(l, adr);
           write(l, string'(", Output: "));
           write(l, mem(conv_integer(adr)));
           
           if (memwrite='1') then
            mem(conv_integer(adr)):=writedata;
          
            write(l, string'(", Input: "));
            write(l, writedata);
           end if;

           writeline(output, l);        
        end if;        
        
    end if;

  end process;

end struct;
