-------------------------------------------------------------------------------
-- File name : mux51x32.vhdl
-- Title     : 5-1 x 32-bit Multiplexor
-- project   : ECE 485
-- Library   : single-cycle processor
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of single-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity mux81 is
  port (D0 : in  std_logic_vector(31 downto 0);
        D1 : in  std_logic_vector(31 downto 0);
        D2 : in  std_logic_vector(31 downto 0);
        D3 : in  std_logic_vector(31 downto 0);
        D4 : in  std_logic_vector(31 downto 0);
        S  : in  std_logic_vector(2 downto 0);
        Y  : out std_logic_vector(31 downto 0));
end mux81;

architecture structure of mux81 is

  component mux51
    port (D0 : in  std_logic;
          D1 : in  std_logic;
          D2 : in  std_logic;
          D3 : in  std_logic;
          D4 : in  std_logic;
          S  : in  std_logic_vector(2 downto 0);
          Y  : out std_logic);
  end component;
    
begin

  mux1  : mux51 port map (D0(0), D1(0), D2(0), D3(0), D4(0), S, Y(0));
  mux2  : mux51 port map (D0(1), D1(1), D2(1), D3(1), D4(1), S, Y(1));
  mux3  : mux51 port map (D0(2), D1(2), D2(2), D3(2), D4(2), S, Y(2));
  mux4  : mux51 port map (D0(3), D1(3), D2(3), D3(3), D4(3), S, Y(3));
  mux5  : mux51 port map (D0(4), D1(4), D2(4), D3(4), D4(4), S, Y(4));
  mux6  : mux51 port map (D0(5), D1(5), D2(5), D3(5), D4(5), S, Y(5));
  mux7  : mux51 port map (D0(6), D1(6), D2(6), D3(6), D4(6), S, Y(6));
  mux8  : mux51 port map (D0(7), D1(7), D2(7), D3(7), D4(7), S, Y(7));
  mux9  : mux51 port map (D0(8), D1(8), D2(8), D3(8), D4(8), S, Y(8));
  mux10 : mux51 port map (D0(9), D1(9), D2(9), D3(9), D4(9), S, Y(9));

  mux11 : mux51 port map (D0(10), D1(10), D2(10), D3(10), D4(10), S, Y(10));
  mux12 : mux51 port map (D0(11), D1(11), D2(11), D3(11), D4(11), S, Y(11));
  mux13 : mux51 port map (D0(12), D1(12), D2(12), D3(12), D4(12), S, Y(12));
  mux14 : mux51 port map (D0(13), D1(13), D2(13), D3(13), D4(13), S, Y(13));
  mux15 : mux51 port map (D0(14), D1(14), D2(14), D3(14), D4(14), S, Y(14));
  mux16 : mux51 port map (D0(15), D1(15), D2(15), D3(15), D4(15), S, Y(15));
  mux17 : mux51 port map (D0(16), D1(16), D2(16), D3(16), D4(16), S, Y(16));
  mux18 : mux51 port map (D0(17), D1(17), D2(17), D3(17), D4(17), S, Y(17));
  mux19 : mux51 port map (D0(18), D1(18), D2(18), D3(18), D4(18), S, Y(18));
  mux20 : mux51 port map (D0(19), D1(19), D2(19), D3(19), D4(19), S, Y(19));

  mux21 : mux51 port map (D0(20), D1(20), D2(20), D3(20), D4(20), S, Y(20));
  mux22 : mux51 port map (D0(21), D1(21), D2(21), D3(21), D4(21), S, Y(21));
  mux23 : mux51 port map (D0(22), D1(22), D2(22), D3(22), D4(22), S, Y(22));
  mux24 : mux51 port map (D0(23), D1(23), D2(23), D3(23), D4(23), S, Y(23));
  mux25 : mux51 port map (D0(24), D1(24), D2(24), D3(24), D4(24), S, Y(24));
  mux26 : mux51 port map (D0(25), D1(25), D2(25), D3(25), D4(25), S, Y(25));
  mux27 : mux51 port map (D0(26), D1(26), D2(26), D3(26), D4(26), S, Y(26));
  mux28 : mux51 port map (D0(27), D1(27), D2(27), D3(27), D4(27), S, Y(27));
  mux29 : mux51 port map (D0(28), D1(28), D2(28), D3(28), D4(28), S, Y(28));
  mux30 : mux51 port map (D0(29), D1(29), D2(29), D3(29), D4(29), S, Y(29));

  mux31 : mux51 port map (D0(30), D1(30), D2(30), D3(30), D4(30), S, Y(30));
  mux32 : mux51 port map (D0(31), D1(31), D2(31), D3(31), D4(31), S, Y(31));

end structure;
